import LexicalUnitDisplay from './LexicalUnitDisplay.js';
import LexicalUnitEdit from './LexicalUnitEdit.js';

export default {
  components: {LexicalUnitDisplay, LexicalUnitEdit},
  props: {
    lexicalUnitId: Number
  },
  data () {
    return this.getInitialData();
  },
  methods: {
    getInitialData () {
      return { isEdit: false }
    },
    goToEdit () {
      this.isEdit = true;
    }
  },
  watch: {
    lexicalUnitId () {
      const freshData = this.getInitialData();
      Object.keys(freshData).map(key => {
        this[key] = freshData[key];
      });
    }
  },

  template: `
    <lexical-unit-display v-if="lexicalUnitId && !isEdit" :lexicalUnitId="lexicalUnitId" @go-to-edit="goToEdit" />
    <lexical-unit-edit v-if="isEdit" :lexicalUnitId="lexicalUnitId" />
  `
}
